var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import React, { Component } from 'react';
import OceanThemeSetting from '../OceanThemeSetting';
import './index.scss';
import { getAPI, getHost } from '../shared';
import { RMCOceanTheme, OceanThemeFormData } from '@beisen/bsapp-mobile-complex-ui';
import _ from 'lodash';
var OceanTheme = /** @class */ (function (_super) {
    __extends(OceanTheme, _super);
    function OceanTheme(props) {
        var _this = _super.call(this, props) || this;
        _this.getOceanCommponetList = function (id) {
            var self = _this;
            var oceanThemeId = id ? id : self.state.oceanThemeId;
            var userId = window.BSGlobal.loginUserInfo.Id;
            var tenantId = window.BSGlobal.tenantInfo.Id;
            var oceanApi = getAPI({
                baseUrl: getHost('ocean'),
                apiPath: 'Dashboard/GetDashboardInfo?dashboardId=' + oceanThemeId + '&tenantId=' + tenantId + '&userId=' + userId,
            });
            // console.log(oceanApi)
            fetch(oceanApi, {
                credentials: 'include',
            }).then(function (ret) {
                return ret.json();
            }).then(function (ret) {
                if (ret && ret.data && ret.data.dashboardId) {
                    _this.setState({
                        oceanThemeName: ret.data.dashboardName
                    });
                    var componentList_1 = [];
                    _.map(ret.data.board, function (item) {
                        var chartType = Number(item.chartType);
                        if (chartType === 23 || chartType === 22 || chartType === 26 || item.chartType === 'echart') {
                            return;
                        }
                        else {
                            componentList_1.push({ componentId: item.componentId, componentName: item.componentName, chartType: item.chartType });
                        }
                    });
                    // console.log(componentList)
                    var cTopNum = componentList_1.length % 3;
                    _this.setState({
                        chartListTop: [],
                        chartList: [] //处理修改主题时组件不更新或重叠的问题
                    });
                    if (cTopNum) {
                        var componentListTop = componentList_1.splice(0, cTopNum);
                        _this.setState({
                            componentListTop: componentListTop,
                        });
                        _this.getOceanChartTopAction({ componentListTop: componentListTop, oceanThemeId: oceanThemeId });
                    }
                    _this.setState({
                        componentList: componentList_1,
                    });
                    _this.getOceanChartAction({ componentList: componentList_1, oceanThemeId: oceanThemeId });
                    // alert(this.state.chartList.length)
                }
            });
        };
        _this.getOceanChartAction = function (datas) {
            var self = _this;
            var oceanThemeDatas = [], oceanThemeId = datas.oceanThemeId, componentList = datas.componentList, componentListNum = componentList.length;
            Promise.all(_.map(componentList, function (item, index) {
                var rows = 3;
                if (item.chartType === 0 || item.chartType === 15) { // 区域图, 折线
                    rows = 4;
                }
                if (item.chartType === 7 || item.chartType === 16) {
                    // 雷达图，雷达面积图
                    rows = 6;
                }
                if (item.chartType === 2 || item.chartType === 8 || item.chartType === 11 || item.chartType === 14) {
                    // 饼类
                    rows = 11; // 最多显示10条，超过10条显示占位图，这里请求11条去判断总数是否超过10条
                }
                if (item.chartType === 3) {
                    // 堆叠图
                    rows = 20; //
                }
                var userId = window.BSGlobal.loginUserInfo.Id;
                var tenantId = window.BSGlobal.tenantInfo.Id;
                var url = getAPI({
                    baseUrl: getHost('ocean'),
                    apiPath: 'Dashboard/GetChart?dashboardId=' + oceanThemeId + '&tenantId=' + tenantId + '&userId=' + userId + '&r=' + item.componentId + '&showRows=' + rows,
                }), componentName = item.componentName, componentId = item.componentId, chartType = item.chartType;
                var datas = {
                    chartType: chartType,
                    componentId: componentId,
                    oceanThemeId: oceanThemeId,
                    componentName: componentName,
                    url: url,
                    componentListNum: componentListNum,
                    isTop: false,
                };
                return self.getChart(datas).then(function (ret) {
                    // ret.__orderIndex = index;
                    oceanThemeDatas.push(ret);
                });
            })).then(function () {
                self.setState({
                    chartList: oceanThemeDatas,
                });
            });
        };
        _this.getOceanChartTopAction = function (datas) {
            var self = _this;
            var oceanThemeDatas = [], oceanThemeId = datas.oceanThemeId, componentList = datas.componentListTop, componentListNum = componentList.length;
            Promise.all(_.map(componentList, function (item, index) {
                var rows = 3;
                if (item.chartType === 0 || item.chartType === 15) { //区域图, 折线
                    rows = 4;
                }
                if (item.chartType === 7 || item.chartType === 16) {
                    // 雷达图，雷达面积图
                    rows = 6;
                }
                if (item.chartType === 2 || item.chartType === 8 || item.chartType === 11 || item.chartType === 14) {
                    // 饼类
                    rows = 11; //最多显示10条，超过10条显示占位图，这里请求11条去判断总数是否超过10条
                }
                if (item.chartType === 3) {
                    // 堆叠图
                    rows = 20;
                }
                var userId = window.BSGlobal.loginUserInfo.Id;
                var tenantId = window.BSGlobal.tenantInfo.Id;
                var url = getAPI({
                    baseUrl: getHost('ocean'),
                    apiPath: 'Dashboard/GetChart?dashboardId=' + oceanThemeId + '&tenantId=' + tenantId + '&userId=' + userId + '&r=' + item.componentId + '&showRows=' + rows,
                });
                var componentName = item.componentName;
                var componentId = item.componentId;
                var chartType = item.chartType;
                var datas = {
                    chartType: chartType,
                    componentId: componentId,
                    oceanThemeId: oceanThemeId,
                    componentName: componentName,
                    url: url,
                    componentListNum: componentListNum,
                    isTop: true,
                };
                return self.getChart(datas).then(function (ret) {
                    // oceanThemeDatas.push(ret);
                    oceanThemeDatas[index] = ret;
                });
            })).then(function () {
                self.setState({
                    chartListTop: oceanThemeDatas,
                    loading: false,
                });
            });
        };
        _this.getChart = function (oceanDatas) {
            var url = oceanDatas.url;
            var oceanThemeItem;
            return new Promise(function (resolve, reject) {
                fetch(url, {
                    credentials: 'include',
                }).then(function (ret) {
                    return ret.json();
                }).then(function (ret) {
                    if (ret && ret.data && ret.data.ChartDataOptions) {
                        oceanThemeItem = OceanThemeFormData(oceanDatas, ret.data);
                    }
                    resolve(oceanThemeItem);
                });
            }).then(function () {
                return oceanThemeItem;
            });
        };
        _this.clickItem = function () {
        };
        _this.state = {
            oceanThemeId: props.data.OceanThemeSetting && props.data.OceanThemeSetting.oceanThemeId || '',
            oceanThemeName: '',
            componentList: [],
            componentListTop: [],
            chartList: [],
            chartListTop: [],
            loading: true,
        };
        return _this;
    }
    OceanTheme.getEditProps = function () {
        return [{
                pType: OceanThemeSetting,
                name: 'Ocean设置',
                key: 'OceanThemeSetting',
                defaultValue: {
                    "oceanThemeId": "",
                    "oceanThemeName": "",
                }
            }];
    };
    OceanTheme.prototype.componentDidMount = function () {
        this.getOceanCommponetList();
    };
    OceanTheme.prototype.componentWillReceiveProps = function (nextProps) {
        if (nextProps.data.OceanThemeSetting && nextProps.data.OceanThemeSetting.oceanThemeId && nextProps.data.OceanThemeSetting.oceanThemeId !== this.state.oceanThemeId) {
            this.setState({
                oceanThemeId: nextProps.data.OceanThemeSetting.oceanThemeId
            });
            this.getOceanCommponetList(nextProps.data.OceanThemeSetting.oceanThemeId);
        }
    };
    OceanTheme.prototype.render = function () {
        var _a = this.state, oceanThemeName = _a.oceanThemeName, chartList = _a.chartList, chartListTop = _a.chartListTop;
        console.log(JSON.stringify(chartList.length));
        var empty = !chartList.length && !chartListTop.length;
        // console.log(this.props)
        return (React.createElement("div", { className: "ocean-theme" },
            React.createElement(RMCOceanTheme, { key: this.props.id, empty: empty, loading: false, title: oceanThemeName, chartList: chartList, clickItem: this.clickItem, chartListTop: chartListTop })));
    };
    return OceanTheme;
}(Component));
export default OceanTheme;
