var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import 'whatwg-fetch';
import React, { Component } from 'react';
import find from 'lodash/find';
import { throttle } from 'core-decorators';
import AutoComplete from 'antd/lib/auto-complete'; // 加载 JS
import 'antd/lib/auto-complete/style/css';
import './index.scss';
import { getAPI, getHost } from '../shared';
// function onSelect(value) {
//   console.log('onSelect', value);
// }
var OceanThemeSetting = /** @class */ (function (_super) {
    __extends(OceanThemeSetting, _super);
    function OceanThemeSetting(props) {
        var _this = _super.call(this, props) || this;
        _this.handleSearch = _this.handleSearch.bind(_this);
        _this.handleChangeEditMode = _this.handleChangeEditMode.bind(_this);
        _this.handleChangeNormalMode = _this.handleChangeNormalMode.bind(_this);
        _this.handleSave = _this.handleSave.bind(_this);
        _this.handleSelect = _this.handleSelect.bind(_this);
        _this.onChange = _this.onChange.bind(_this);
        _this.onFocus = _this.onFocus.bind(_this);
        _this.getOceanThemeName = _this.getOceanThemeName.bind(_this);
        _this.state = {
            dataSource: [],
            mode: props.data.oceanThemeId ? 'normal' : 'edit',
            oceanThemeId: props.data.oceanThemeId || '',
            oceanThemeName: props.data.oceanThemeName,
            oceanThemeValue: props.data.oceanThemeName,
            oceanThemeValueProps: props.data.oceanThemeName,
        };
        return _this;
    }
    OceanThemeSetting.prototype.componentWillMount = function () {
        this.getOceanThemeName();
    };
    OceanThemeSetting.prototype.getOceanThemeName = function () {
        var _this = this;
        var oceanThemeId = this.state.oceanThemeId;
        var userId = window.BSGlobal.loginUserInfo.Id;
        var tenantId = window.BSGlobal.tenantInfo.Id;
        var oceanApi = getAPI({
            baseUrl: getHost('ocean'),
            apiPath: 'Dashboard/GetDashboardInfo?dashboardId=' + oceanThemeId + '&tenantId=' + tenantId + '&userId=' + userId,
        });
        fetch(oceanApi, {
            credentials: 'include'
        }).then(function (ret) {
            return ret.json();
        })
            .then(function (ret) {
            if (ret && ret.data && ret.data.dashboardId) {
                _this.setState({
                    oceanThemeValue: ret.data.dashboardName,
                    oceanThemeName: ret.data.dashboardName
                });
            }
        });
    };
    OceanThemeSetting.prototype.handleChangeEditMode = function () {
        this.setState({
            mode: 'edit',
        });
        var update = this.props.update;
        var _a = this.state, oceanThemeId = _a.oceanThemeId, oceanThemeName = _a.oceanThemeName;
        update({
            oceanThemeId: oceanThemeId,
            oceanThemeName: oceanThemeName,
        });
    };
    //点击取消按钮
    OceanThemeSetting.prototype.handleChangeNormalMode = function () {
        this.setState({
            mode: 'normal',
            oceanThemeValue: this.state.oceanThemeName,
        });
    };
    // 搜索
    OceanThemeSetting.prototype.handleSearch = function (val) {
        var _this = this;
        var oceanApi = getAPI({
            baseUrl: getHost('ocean'),
            apiPath: 'Widget/GetAllSysAndTenantDashBoard?tenantId=' + window.BSGlobal.tenantInfo.Id + '&searchKey=' + val,
        });
        fetch(oceanApi, {
            credentials: 'include' //加cookie
        }).then(function (ret) {
            return ret.json();
        })
            .then(function (ret) {
            if (ret.code == 200) {
                var data = ret.data;
                var dataSource = data.map(function (item) {
                    return {
                        text: item.DashboardName,
                        value: item.DashboardId,
                    };
                });
                _this.setState({
                    dataSource: dataSource,
                });
            }
        });
    };
    OceanThemeSetting.prototype.onChange = function (oceanThemeId) {
        var update = this.props.update;
        var dataSource = this.state.dataSource;
        var targetTheme = find(dataSource, function (item) {
            return item.value === oceanThemeId;
        });
        // console.log(targetTheme)
        if (!targetTheme) {
            this.setState({
                oceanThemeValue: oceanThemeId,
            });
            return;
        }
        if (!oceanThemeId) {
            // this.setState({
            //   oceanThemeValue: this.state.oceanThemeName,
            // });
            return;
        }
        this.setState({
            oceanThemeValue: oceanThemeId,
            oceanThemeId: oceanThemeId,
            oceanThemeName: targetTheme.text,
        }, function () {
            update({
                oceanThemeId: oceanThemeId,
                oceanThemeName: targetTheme.text,
            });
        });
    };
    OceanThemeSetting.prototype.onFocus = function () {
        // console.log(this.state.oceanThemeValue)
        if (!this.state.oceanThemeValue) {
            this.handleSearch('');
        }
    };
    OceanThemeSetting.prototype.handleSave = function () {
        var update = this.props.update;
        var _a = this.state, oceanThemeId = _a.oceanThemeId, oceanThemeName = _a.oceanThemeName;
        if (!oceanThemeId || !this.state.oceanThemeValue) {
            return;
        }
        update({
            oceanThemeId: oceanThemeId,
            oceanThemeName: oceanThemeName,
        });
        this.handleChangeNormalMode();
    };
    OceanThemeSetting.prototype.handleSelect = function (oceanThemeId) {
        var dataSource = this.state.dataSource;
        var targetTheme = find(dataSource, function (item) {
            return item.value === oceanThemeId;
        });
        this.setState({
            oceanThemeId: oceanThemeId,
            oceanThemeName: targetTheme.text,
        });
    };
    OceanThemeSetting.prototype.render = function () {
        var _a = this.state, dataSource = _a.dataSource, mode = _a.mode, oceanThemeName = _a.oceanThemeName, oceanThemeId = _a.oceanThemeId, oceanThemeValue = _a.oceanThemeValue;
        var cls = !oceanThemeValue ? 'banner-setting-button-sure-empty' : 'banner-setting-button-sure';
        return (React.createElement("div", { className: 'oceantheme_setting__container' },
            React.createElement("div", { className: "label" }, "\u4E3B\u9898"),
            React.createElement(AutoComplete, { dataSource: dataSource, onSelect: this.handleSelect, onSearch: this.handleSearch, placeholder: "\u8BF7\u8F93\u5165\u4E3B\u9898", value: oceanThemeValue, autoFocus: mode !== 'normal', onChange: this.onChange, onFocus: this.onFocus, allowClear: true })));
    };
    __decorate([
        throttle(500, { leading: false })
        // 搜索
        ,
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], OceanThemeSetting.prototype, "handleSearch", null);
    return OceanThemeSetting;
}(Component));
export default OceanThemeSetting;
